summaryrefslogtreecommitdiff
path: root/lemon/scripts/valgrind-wrapper.sh
diff options
context:
space:
mode:
Diffstat (limited to 'lemon/scripts/valgrind-wrapper.sh')
-rwxr-xr-xlemon/scripts/valgrind-wrapper.sh22
1 files changed, 22 insertions, 0 deletions
diff --git a/lemon/scripts/valgrind-wrapper.sh b/lemon/scripts/valgrind-wrapper.sh
new file mode 100755
index 0000000..bbb1222
--- /dev/null
+++ b/lemon/scripts/valgrind-wrapper.sh
@@ -0,0 +1,22 @@
+#!/bin/sh
+
+# Run in valgrind, with leak checking enabled
+
+valgrind -q --leak-check=full "$@" 2> .valgrind-log
+
+# Save the test result
+
+result="$?"
+
+# Valgrind should generate no error messages
+
+log_contents="`cat .valgrind-log`"
+
+if [ "$log_contents" != "" ]; then
+ cat .valgrind-log >&2
+ result=1
+fi
+
+rm -f .valgrind-log
+
+exit $result